/* Copyright(C) 2004-2005 Brazil

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SEN_SNIP_H
#define _SEN_SNIP_H

#ifndef _SENNA_H
#include "senna_in.h"
#endif /* _SENNA_H */

#ifdef  __cplusplus
extern "C" {
#endif

#include "str.h"

typedef struct {
  int *bmGs;
  int *bmBc;
  int keyword_len;
  int opentag_len;
  int closetag_len;
  sen_nstr *keyword;
  const char *opentag;
  const char *closetag;
} sen_snippet_cond;

sen_snippet_cond *sen_snip_cond_open(const char *keyword, sen_encoding encoding, int flags, const char *opentag, const char *closetag);
sen_rc sen_snip_cond_close(sen_snippet_cond *cond);
sen_rc sen_snip_snippet_open(const char *string, sen_encoding encoding, int flags, int width,
int cond_len, sen_snippet_cond **cond, int max_results, int *result_len, char ***results);
sen_rc sen_snip_snippet_close(char **results);

#ifdef __cplusplus
}
#endif

#endif /* _SEN_SNIP_H */
